import flet as ft
import inspect

control_icons = {
    "AppBar": ft.icons.NAVIGATION_SHARP,
    "Banner": ft.icons.NOTIFICATIONS_ROUNDED,
    "BottomSheet": ft.icons.EXPAND_MORE,
    "Button": ft.icons.SMART_BUTTON_ROUNDED,
    "Card": ft.icons.CREDIT_CARD,
    "Checkbox": ft.icons.CHECK_BOX,
    "Chip": ft.icons.LABEL,
    "CircularProgressIndicator": ft.icons.BLUR_CIRCULAR_ROUNDED,
    "Column": ft.icons.VIEW_LIST,
    "Container": ft.icons.CROP_DIN,
    "DataTable": ft.icons.TABLE_CHART,
    "Dialog": ft.icons.SIM_CARD_ALERT,
    "Divider": ft.icons.VERTICAL_ALIGN_CENTER_ROUNDED,
    "Dropdown": ft.icons.ARROW_DROP_DOWN,
    "ElevatedButton": ft.icons.CHECK_BOX,
    "FloatingActionButton": ft.icons.ADD_CIRCLE,
    "GridView": ft.icons.GRID_ON,
    "IconButton": ft.icons.INSERT_EMOTICON_ROUNDED,
    "Image": ft.icons.IMAGE,
    "LinearProgressIndicator": ft.icons.LINEAR_SCALE,
    "ListTile": ft.icons.VIEW_HEADLINE,
    "ListView": ft.icons.LIST,
    "NavigationBar": ft.icons.NAVIGATION,
    "OutlinedButton": ft.icons.CHECK_BOX_OUTLINE_BLANK,
    "Padding": ft.icons.PADDING,
    "PopupMenuButton": ft.icons.MORE_VERT,
    "RadioButton": ft.icons.RADIO_BUTTON_CHECKED,
    "Row": ft.icons.VIEW_COLUMN,
    "SafeArea": ft.icons.SECURITY,
    "Slider": ft.icons.TUNE,
    "SnackBar": ft.icons.BARCODE_READER,
    "Stack": ft.icons.STACKED_LINE_CHART,
    "Switch": ft.icons.TOGGLE_ON,
    "TabBar": ft.icons.TAB,
    "Text": ft.icons.TEXT_FIELDS,
    "TextField": ft.icons.INPUT,
    "Tooltip": ft.icons.TOOLTIP,
    "VerticalDivider": ft.icons.VERTICAL_SPLIT,
    "AnimatedContainer": ft.icons.ANIMATION,
    "Audio": ft.icons.AUDIOTRACK,
    "Badge": ft.icons.BADGE,
    "Banner": ft.icons.NOTIFICATIONS_ROUNDED,
    "BottomAppBar": ft.icons.BOTTOM_APP_BAR,
    "BottomNavigationBar": ft.icons.BOTTOM_NAVIGATION,
    "ButtonBar": ft.icons.BUTTON_BAR,
    "CalendarDatePicker": ft.icons.CALENDAR_TODAY,
    "Card": ft.icons.CARD_GIFTCARD,
    "CheckboxListTile": ft.icons.CHECK_BOX_OUTLINE_BLANK,
    "Chip": ft.icons.CHIP,
    "CircularProgressIndicator": ft.icons.BLUR_CIRCULAR_ROUNDED,
    "ClipRRect": ft.icons.CROP,
    "Column": ft.icons.COLUMN,
    "ConstrainedBox": ft.icons.CHECK_BOX_OUTLINE_BLANK,
    "CupertinoActionSheet": ft.icons.CUPERTINO,
    "CupertinoActivityIndicator": ft.icons.CUPERTINO,
    "CupertinoAlertDialog": ft.icons.CUPERTINO,
    "CupertinoButton": ft.icons.CUPERTINO,
    "CupertinoContextMenu": ft.icons.CUPERTINO,
    "CupertinoDatePicker": ft.icons.CUPERTINO,
    "CupertinoDialog": ft.icons.CUPERTINO,
    "CupertinoDialogAction": ft.icons.CUPERTINO,
    "CupertinoFullscreenDialogTransition": ft.icons.CUPERTINO,
    "CupertinoNavigationBar": ft.icons.CUPERTINO,
    "CupertinoPageScaffold": ft.icons.CUPERTINO,
    "CupertinoPageTransition": ft.icons.CUPERTINO,
    "CupertinoPicker": ft.icons.CUPERTINO,
    "CupertinoPopupSurface": ft.icons.CUPERTINO,
    "CupertinoScrollbar": ft.icons.CUPERTINO,
    "CupertinoSearchTextField": ft.icons.CUPERTINO,
    "CupertinoSegmentedControl": ft.icons.CUPERTINO,
    "CupertinoSlidingSegmentedControl": ft.icons.CUPERTINO,
    "CupertinoSliverNavigationBar": ft.icons.CUPERTINO,
    "CupertinoSwitch": ft.icons.CUPERTINO,
    "CupertinoTabBar": ft.icons.CUPERTINO,
    "CupertinoTabScaffold": ft.icons.CUPERTINO,
    "CupertinoTabView": ft.icons.CUPERTINO,
    "CupertinoTextField": ft.icons.CUPERTINO,
    "CupertinoTimerPicker": ft.icons.CUPERTINO,
    "CupertinoActionSheetAction": ft.icons.CUPERTINO,
    "DatePickerDialog": ft.icons.DATE_RANGE,
    "DecoratedBox": ft.icons.DECORATION,
    "Dismissible": ft.icons.DELETE,
    "Draggable": ft.icons.DRAG_HANDLE,
    "Drawer": ft.icons.DRAWER,
    "DropdownButton": ft.icons.ARROW_DROP_DOWN,
    "EditableText": ft.icons.EDIT,
    "ElevatedButton": ft.icons.CHECK_BOX,
    "ExpansionPanel": ft.icons.EXPAND,
    "ExpansionPanelList": ft.icons.EXPAND,
    "ExpansionTile": ft.icons.EXPAND,
    "FadeTransition": ft.icons.TRANSITION,
    "FittedBox": ft.icons.FIT_SCREEN,
    "FlatButton": ft.icons.SMART_BUTTON_ROUNDED,
    "Flexible": ft.icons.FLEX,
    "FloatingActionButton": ft.icons.ADD_CIRCLE,
    "Flow": ft.icons.FLOW,
    "Form": ft.icons.FORM,
    "FractionallySizedBox": ft.icons.FRACTION,
    "FutureBuilder": ft.icons.FUTURE,
    "GestureDetector": ft.icons.GESTURE,
    "GridPaper": ft.icons.GRID_ON,
    "Hero": ft.icons.HERO,
    "Icon": ft.icons.INSERT_EMOTICON_ROUNDED,
    "IconButton": ft.icons.ICON_BUTTON,
    "ImageIcon": ft.icons.IMAGE,
    "IndexedStack": ft.icons.INDEX,
    "Ink": ft.icons.INK,
    "InkWell": ft.icons.INK,
    "InputDecorator": ft.icons.INPUT,
    "IntrinsicHeight": ft.icons.HEIGHT,
    "IntrinsicWidth": ft.icons.WIDTH,
    "LayoutBuilder": ft.icons.LAYOUT,
    "LimitedBox": ft.icons.BOX,
    "LinearProgressIndicator": ft.icons.LINEAR_SCALE,
    "ListBody": ft.icons.LIST,
    "ListTile": ft.icons.LIST,
    "ListView": ft.icons.LIST,
    "LongPressDraggable": ft.icons.DRAG_HANDLE,
    "Material": ft.icons.MATERIAL,
    "MaterialBanner": ft.icons.NOTIFICATIONS_ROUNDED,
    "MaterialButton": ft.icons.SMART_BUTTON_ROUNDED,
    "MaterialPageRoute": ft.icons.ROUTE,
    "MediaQuery": ft.icons.QUERY,
    "ModalBarrier": ft.icons.BARRIER,
    "NavigationToolbar": ft.icons.NAVIGATION,
    "Navigator": ft.icons.NAVIGATE,
    "Offstage": ft.icons.OFFSTAGE,
    "Opacity": ft.icons.OPACITY,
    "OutlinedButton": ft.icons.CHECK_BOX_OUTLINE_BLANK,
    "OverflowBox": ft.icons.OVERFLOW,
    "Padding": ft.icons.PADDING,
    "PageStorage": ft.icons.STORAGE,
    "PageView": ft.icons.PAGEVIEW,
    "Placeholder": ft.icons.PLACEHOLDER,
    "PopupMenuButton": ft.icons.MORE_VERT,
    "Positioned": ft.icons.POSITION,
    "RadioButton": ft.icons.RADIO_BUTTON_CHECKED,
    "RefreshIndicator": ft.icons.REFRESH,
    "ReorderableListView": ft.icons.REORDER,
    "RichText": ft.icons.TEXT_FIELDS,
    "RotatedBox": ft.icons.ROTATE,
    "Row": ft.icons.VIEW_COLUMN,
    "SafeArea": ft.icons.SECURITY,
    "Scaffold": ft.icons.SCAFFOLD,
    "ScrollConfiguration": ft.icons.SCROLL,
    "Scrollbar": ft.icons.SCROLL,
    "SelectableText": ft.icons.TEXT_FIELDS,
    "Semantics": ft.icons.SEMANTICS,
    "SimpleDialog": ft.icons.SIM_CARD_ALERT,
    "SingleChildScrollView": ft.icons.SCROLL,
    "SizedBox": ft.icons.BOX,
    "SizedOverflowBox": ft.icons.BOX,
    "Slider": ft.icons.TUNE,
    "SliverAppBar": ft.icons.NAVIGATION_SHARP,
    "SliverChildBuilderDelegate": ft.icons.BUILDER,
    "SliverChildListDelegate": ft.icons.LIST,
    "SliverFixedExtentList": ft.icons.LIST,
    "SliverGrid": ft.icons.GRID_ON,
    "SliverGridDelegateWithFixedCrossAxisCount": ft.icons.GRID_ON,
    "SliverGridDelegateWithMaxCrossAxisExtent": ft.icons.GRID_ON,
    "SliverGridTile": ft.icons.GRID_ON,
    "SliverList": ft.icons.LIST,
    "SliverPadding": ft.icons.PADDING,
    "SliverPersistentHeader": ft.icons.HEADER,
    "SliverToBoxAdapter": ft.icons.BOX,
    "SnackBar": ft.icons.BARCODE_READER,
    "Spacer": ft.icons.SPACE_BAR,
    "Stack": ft.icons.STACKED_LINE_CHART,
    "Stepper": ft.icons.STEP,
    "Switch": ft.icons.TOGGLE_ON,
    "Tab": ft.icons.TAB,
    "TabBar": ft.icons.TAB,
    "TabBarView": ft.icons.TAB,
}


def get_flet_components(module):
    def is_flet_component(obj):
        return (
            inspect.isclass(obj)
            and issubclass(obj, ft.Control)
            and obj is not ft.Control
        )

    components = {}
    for name, obj in inspect.getmembers(module):
        if is_flet_component(obj):
            components[name] = obj
    return components


flet_components = get_flet_components(ft)
print(flet_components)


def main(page: ft.Page):
    list = ft.ListView(
        [
            ft.TextButton(
                content=ft.Icon(control_icons[component], size=10),
                style=ft.ButtonStyle(
                    shape=ft.ContinuousRectangleBorder(radius=20),
                    side=ft.BorderSide(color="#3d424d", width=2),
                    bgcolor="#323741",
                    color="#ffffff",
                ),
                width=80,
                height=80,
                on_click=lambda e: print("Button clicked"),
            )
            for component in flet_components
        ]
    )
    page.add(list)


ft.app(target=main)
